
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

static void	Error(msg)
char		*msg;
{
	(void)fputs(msg,stderr); (void)fputc('\n',stderr); exit(1);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	int		Nx,Ny,lo,up,o0,o,y,x;
	Cell		**cell;
	double		Ux=1.0,Uy=1.0,L=0.0;
	unsigned long	A=0;

	if (argc!=3 && argc!=5) Error("usage : l_a TIFF {Ux Uy} threshold");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	if (argc==5) {
	    Ux=atof(argv[2]);
	    Uy=atof(argv[3]);
	}
	if (argv[argc-1][0]=='-') {
	    lo=0; up=atoi(argv[argc-1]+1);
	}
	else {
	    lo=atoi(argv[argc-1]); up=(int)(Cell)(~0);
	}

#define O(v)	((int)v>=lo && (int)v<=up)

	o0=O(0);

	if (o=O(cell[0][0])) ++A; if (o0!=o) L+=(Ux+Uy);

	for (x=1; x<Nx; x++) {
	    if (o=O(cell[0][x])) ++A; if (o0		 !=o) L+=Ux;
				      if (O(cell[0][x-1])!=o) L+=Uy;
	}
	if (O(cell[0][Nx-1])!=o0) L+=Uy;

	for (y=1; y<Ny; y++) {
	    if (o=O(cell[y][0])) ++A; if (O(cell[y-1][0])!=o) L+=Ux;
				      if (o0		 !=o) L+=Uy;

	    for (x=1; x<Nx; x++) {
		if (o=O(cell[y][x])) ++A; if (O(cell[y-1][x])!=o) L+=Ux;
					  if (O(cell[y][x-1])!=o) L+=Uy;
	    }
	    if (O(cell[y][Nx-1])!=o0) L+=Uy;
	}
	for (x=0; x<Nx; x++) if (O(cell[Ny-1][x])!=o0) L+=Ux;

	(void)printf("%lf\t%lf\n",L,Ux*Uy*(double)A);

	return 0;
}
